Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
$(() => {
const fileManager = $('#file-manager').dxFileManager({
name: 'fileManager',
fileSystemProvider: fileSystem,
height: 450,
permissions: {
create: true,
delete: true,
rename: true,
download: true,
},
itemView: {
details: {
columns: [
'thumbnail', 'name',
{
dataField: 'category',
caption: 'Category',
width: 95,
},
'dateModified', 'size',
],
},
showParentFolder: false,
},
toolbar: {
items: [
{
name: 'showNavPane',
visible: true,
},
'separator', 'create',
{
widget: 'dxMenu',
location: 'before',
options: {
items: [
{
text: 'Create new file',
icon: 'plus',
items: [
{
text: 'Text Document',
extension: '.txt',
},
{
text: 'RTF Document',
extension: '.rtf',
},
{
text: 'Spreadsheet',
extension: '.xls',
},
],
},
],
onItemClick,
},
},
'refresh',
{
name: 'separator',
location: 'after',
},
'switchView',
],
fileSelectionItems: [
'rename', 'separator', 'delete', 'separator',
{
widget: 'dxMenu',
options: {
items: [
{
text: 'Category',
icon: 'tags',
items: [
{
text: 'Work',
category: 'Work',
},
{
text: 'Important',
category: 'Important',
},
{
text: 'Home',
category: 'Home',
},
{
text: 'None',
category: '',
},
],
},
],
onItemClick,
},
location: 'before',
},
'refresh', 'clearSelection',
],
},
onContextMenuItemClick: onItemClick,
contextMenu: {
items: [
'create',
{
text: 'Create new file',
icon: 'plus',
items: [
{
text: 'Text Document',
},
{
text: 'RTF Document',
},
{
text: 'Spreadsheet',
},
],
},
{
name: 'rename',
beginGroup: true,
},
'delete',
{
text: 'Category',
icon: 'tags',
beginGroup: true,
items: [
{
text: 'Work',
},
{
text: 'Important',
},
{
text: 'Home',
},
{
text: 'None',
},
],
},
'refresh',
],
},
}).dxFileManager('instance');
function onItemClick(args) {
let updated = false;
const { extension, category } = getItemInfo(args.itemData.text);
if (extension) {
updated = createFile(extension, args.fileSystemItem);
} else if (category !== undefined) {
updated = updateCategory(category, args.fileSystemItem, args.viewArea);
}
if (updated) {
fileManager.refresh();
}
}
function createFile(fileExtension, directory = fileManager.getCurrentDirectory()) {
const newItem = {
__KEY__: Date.now(),
name: `New file${fileExtension}`,
isDirectory: false,
size: 0,
};
if (!directory.isDirectory) {
return false;
}
let array = null;
if (!directory.dataItem) {
array = fileSystem;
} else {
array = directory.dataItem.items;
if (!array) {
array = [];
directory.dataItem.items = array;
}
}
array.push(newItem);
return true;
}
function updateCategory(newCategory, directory, viewArea) {
let items = null;
if (viewArea === 'navPane') {
items = [directory];
} else {
items = fileManager.getSelectedItems();
}
items.forEach((item) => {
if (item.dataItem) {
item.dataItem.category = newCategory;
}
});
return items.length > 0;
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.1.6/css/dx.light.css" />
<script src="js/dx.all.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="data.js"></script>
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="file-manager"></div>
</div>
</body>
</html>
const fileSystem = [
{
name: 'Documents',
isDirectory: true,
category: 'Work',
items: [
{
name: 'Projects',
isDirectory: true,
category: 'Work',
items: [
{
name: 'About.rtf',
isDirectory: false,
size: 1024,
},
{
name: 'Passwords.rtf',
isDirectory: false,
category: 'Important',
size: 2048,
},
],
},
{
name: 'About.xml',
isDirectory: false,
size: 1024,
},
{
name: 'Managers.rtf',
isDirectory: false,
size: 2048,
},
{
name: 'ToDo.txt',
isDirectory: false,
size: 3072,
},
],
},
{
name: 'Images',
isDirectory: true,
category: 'Home',
items: [
{
name: 'logo.png',
isDirectory: false,
size: 20480,
},
{
name: 'banner.gif',
isDirectory: false,
size: 10240,
},
],
},
{
name: 'System',
isDirectory: true,
category: 'Important',
items: [
{
name: 'Employees.txt',
isDirectory: false,
category: 'Important',
size: 3072,
},
{
name: 'PasswordList.txt',
isDirectory: false,
category: 'Important',
size: 5120,
},
],
},
{
name: 'Description.rtf',
isDirectory: false,
size: 1024,
},
{
name: 'Description.txt',
isDirectory: false,
size: 2048,
},
];
const fileExtensions = {
'Text Document': '.txt',
'RTF Document': '.rtf',
Spreadsheet: '.xls',
};
const categories = ['Work', 'Important', 'Home', 'None'];
function getItemInfo(name) {
const extension = fileExtensions[name];
const category = extension || categories.find((cat) => cat === name);
return {
extension,
category,
};
}

Backend API
<dx-file-manager
id="fileManager"
[fileSystemProvider]="fileItems"
(onContextMenuItemClick)="onItemClick($event)"
height="450"
>
<dxo-file-manager-permissions
[create]="true"
[delete]="true"
[rename]="true"
[download]="true"
>
</dxo-file-manager-permissions>
<dxo-file-manager-item-view [showParentFolder]="false">
<dxo-file-manager-details>
<dxi-file-manager-column dataField="thumbnail"></dxi-file-manager-column>
<dxi-file-manager-column dataField="name"></dxi-file-manager-column>
<dxi-file-manager-column
dataField="category"
caption="Category"
width="95"
></dxi-file-manager-column>
<dxi-file-manager-column
dataField="dateModified"
></dxi-file-manager-column>
<dxi-file-manager-column dataField="size"></dxi-file-manager-column>
</dxo-file-manager-details>
</dxo-file-manager-item-view>
<dxo-file-manager-toolbar>
<dxi-file-manager-item
name="showNavPane"
[visible]="true"
></dxi-file-manager-item>
<dxi-file-manager-item name="separator"></dxi-file-manager-item>
<dxi-file-manager-item name="create"></dxi-file-manager-item>
<dxi-file-manager-item
widget="dxMenu"
location="before"
[options]="newFileMenuOptions"
></dxi-file-manager-item>
<dxi-file-manager-item name="refresh"></dxi-file-manager-item>
<dxi-file-manager-item
name="separator"
location="after"
></dxi-file-manager-item>
<dxi-file-manager-item name="switchView"></dxi-file-manager-item>
<dxi-file-manager-file-selection-item
name="rename"
></dxi-file-manager-file-selection-item>
<dxi-file-manager-file-selection-item
name="separator"
></dxi-file-manager-file-selection-item>
<dxi-file-manager-file-selection-item
name="delete"
></dxi-file-manager-file-selection-item>
<dxi-file-manager-file-selection-item
name="separator"
></dxi-file-manager-file-selection-item>
<dxi-file-manager-file-selection-item
widget="dxMenu"
location="before"
[options]="changeCategoryMenuOptions"
></dxi-file-manager-file-selection-item>
<dxi-file-manager-file-selection-item
name="refresh"
></dxi-file-manager-file-selection-item>
<dxi-file-manager-file-selection-item
name="clearSelection"
></dxi-file-manager-file-selection-item>
</dxo-file-manager-toolbar>
<dxo-file-manager-context-menu>
<dxi-file-manager-item name="create"></dxi-file-manager-item>
<dxi-file-manager-item text="Create new file" icon="plus">
<dxi-file-manager-item text="Text Document"></dxi-file-manager-item>
<dxi-file-manager-item text="RTF Document"></dxi-file-manager-item>
<dxi-file-manager-item text="Spreadsheet"></dxi-file-manager-item>
</dxi-file-manager-item>
<dxi-file-manager-item
name="rename"
[beginGroup]="true"
></dxi-file-manager-item>
<dxi-file-manager-item name="delete"></dxi-file-manager-item>
<dxi-file-manager-item text="Category" icon="tags" [beginGroup]="true">
<dxi-file-manager-item text="Work"></dxi-file-manager-item>
<dxi-file-manager-item text="Important"></dxi-file-manager-item>
<dxi-file-manager-item text="Home"></dxi-file-manager-item>
<dxi-file-manager-item text="None"></dxi-file-manager-item>
</dxi-file-manager-item>
<dxi-file-manager-item name="refresh"></dxi-file-manager-item>
</dxo-file-manager-context-menu>
</dx-file-manager>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, ViewChild, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxFileManagerModule, DxFileManagerComponent, DxFileManagerTypes } from 'devextreme-angular/ui/file-manager';
import { Service, FileItem } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
styleUrls: [`app/app.component.css`],
selector: 'demo-app',
templateUrl: `app/app.component.html`,
providers: [Service],
preserveWhitespaces: true,
imports: [
DxFileManagerModule,
],
})
export class AppComponent {
@ViewChild(DxFileManagerComponent, { static: false }) fileManager: DxFileManagerComponent;
fileItems: FileItem[];
newFileMenuOptions = {
items: [
{
text: 'Create new file',
icon: 'plus',
items: [
{
text: 'Text Document',
},
{
text: 'RTF Document',
},
{
text: 'Spreadsheet',
},
],
},
],
onItemClick: this.onItemClick.bind(this),
};
changeCategoryMenuOptions = {
items: [
{
text: 'Category',
icon: 'tags',
beginGroup: true,
items: [
{
text: 'Work',
},
{
text: 'Important',
},
{
text: 'Home',
},
{
text: 'None',
},
],
},
],
onItemClick: this.onItemClick.bind(this),
};
private service: Service;
constructor(service: Service) {
this.service = service;
this.fileItems = service.getFileItems();
this.onItemClick = this.onItemClick.bind(this);
}
onItemClick({ itemData, viewArea, fileSystemItem }: DxFileManagerTypes.ContextMenuItemClickEvent): void {
let updated = false;
const { extension, category } = this.service.getItemInfo(itemData.text);
if (extension) {
updated = this.createFile(extension, fileSystemItem);
} else if (category !== undefined) {
updated = this.updateCategory(category, fileSystemItem, viewArea);
}
if (updated) {
this.fileManager.instance.refresh();
}
}
createFile(
fileExtension,
directory = this.fileManager.instance.getCurrentDirectory()
) {
const newItem = {
__KEY__: Date.now(),
name: `New file${fileExtension}`,
isDirectory: false,
size: 0,
};
if (!directory.isDirectory) {
return false;
}
let array = null;
if (!directory.dataItem) {
array = this.fileItems;
} else {
array = directory.dataItem.items;
if (!array) {
directory.dataItem.items = [];
array = [];
}
}
array.push(newItem);
return true;
}
updateCategory(newCategory, directory, viewArea) {
let items = null;
if (viewArea === 'navPane') {
items = [directory];
} else {
items = this.fileManager.instance.getSelectedItems();
}
items.forEach((item) => {
if (item.dataItem) {
item.dataItem.category = newCategory;
}
});
return items.length > 0;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
import { Injectable } from '@angular/core';
export class FileItem {
name: string;
isDirectory: boolean;
category?: string;
size?: number;
items?: FileItem[];
}
const fileItems: FileItem[] = [{
name: 'Documents',
isDirectory: true,
category: 'Work',
items: [{
name: 'Projects',
isDirectory: true,
category: 'Work',
items: [{
name: 'About.rtf',
isDirectory: false,
size: 1024,
}, {
name: 'Passwords.rtf',
isDirectory: false,
category: 'Important',
size: 2048,
}],
}, {
name: 'About.xml',
isDirectory: false,
size: 1024,
}, {
name: 'Managers.rtf',
isDirectory: false,
size: 2048,
}, {
name: 'ToDo.txt',
isDirectory: false,
size: 3072,
}],
}, {
name: 'Images',
isDirectory: true,
category: 'Home',
items: [{
name: 'logo.png',
isDirectory: false,
size: 20480,
}, {
name: 'banner.gif',
isDirectory: false,
size: 10240,
}],
}, {
name: 'System',
isDirectory: true,
category: 'Important',
items: [{
name: 'Employees.txt',
isDirectory: false,
category: 'Important',
size: 3072,
}, {
name: 'PasswordList.txt',
isDirectory: false,
category: 'Important',
size: 5120,
}],
}, {
name: 'Description.rtf',
isDirectory: false,
size: 1024,
}, {
name: 'Description.txt',
isDirectory: false,
size: 2048,
}];
const fileExtensions = {
'Text Document': '.txt',
'RTF Document': '.rtf',
Spreadsheet: '.xls',
};
const categories = ['Work', 'Important', 'Home', 'None'];
@Injectable()
export class Service {
getFileItems(): FileItem[] {
return fileItems;
}
getItemInfo(name: string) {
const extension = fileExtensions[name];
const category = extension ?? categories.find((cat) => cat === name);
return {
extension,
category,
};
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Vue File Manager - Toolbar and Context Menu

The FileManager component provides the following UI customization properties:

  • The toolbar property specifies the toolbar's visibility and available commands.
  • The contextMenu property specifies the context menu's availability and its commands.

The toolbar and context menu support context-invariant and context-sensitive items that can be visible or hidden depending on user action.

Backend API
<template> <DxFileManager ref="fileManager" :file-system-provider="fileItems" @context-menu-item-click="onItemClick" :height="450" > <DxPermissions :create="true" :copy="true" :move="true" :delete="true" :rename="true" /> <DxItemView :show-parent-folder="false" > <DxDetails> <DxColumn data-field="thumbnail"/> <DxColumn data-field="name"/> <DxColumn data-field="category" caption="Category" :width="95" /> <DxColumn data-field="dateModified"/> <DxColumn data-field="size"/> </DxDetails> </DxItemView> <DxToolbar> <DxItem name="showNavPane" :visible="true" /> <DxItem name="separator"/> <DxItem name="create"/> <DxItem widget="dxMenu" location="before" :options="newFileMenuOptions" /> <DxItem name="refresh"/> <DxItem name="separator" location="after" /> <DxItem name="switchView"/> <DxFileSelectionItem name="rename"/> <DxFileSelectionItem name="separator"/> <DxFileSelectionItem name="delete"/> <DxFileSelectionItem name="separator"/> <DxFileSelectionItem widget="dxMenu" location="before" :options="changeCategoryMenuOptions" /> <DxFileSelectionItem name="refresh"/> <DxFileSelectionItem name="clearSelection"/> </DxToolbar> <DxContextMenu> <DxItem name="create"/> <DxItem text="Create new file" icon="plus" > <DxItem text="Text Document"/> <DxItem text="RTF Document"/> <DxItem text="Spreadsheet"/> </DxItem> <DxItem name="rename" :begin-group="true" /> <DxItem name="delete"/> <DxItem text="Category" icon="tags" :begin-group="true" > <DxItem text="Work"/> <DxItem text="Important"/> <DxItem text="Home"/> <DxItem text="None"/> </DxItem> </DxContextMenu> </DxFileManager> </template> <script setup lang="ts"> import { ref } from 'vue'; import { DxFileManager, DxPermissions, DxToolbar, DxContextMenu, DxItem, DxFileSelectionItem, DxItemView, DxDetails, DxColumn, type DxFileManagerTypes, } from 'devextreme-vue/file-manager'; import FileSystemItem from 'devextreme/file_management/file_system_item'; import { fileItems, getItemInfo } from './data.ts'; const newFileMenuOptions = getNewFileMenuOptions(); const changeCategoryMenuOptions = getChangeCategoryMenuOptions(); const fileManager = ref(); function onItemClick( { itemData, viewArea, fileSystemItem }: DxFileManagerTypes.ContextMenuItemClickEvent, ) { let updated = false; const { extension, category } = getItemInfo(itemData.text); if (extension) { updated = createFile(extension, fileSystemItem); } else if (category !== undefined && fileSystemItem) { updated = updateCategory(category, fileSystemItem, viewArea); } if (updated) { fileManager.value.instance.refresh(); } } function createFile( fileExtension: string, directory: any = fileManager.value.instance.getCurrentDirectory(), ) { const newItem = { __KEY__: Date.now(), name: `New file${fileExtension}`, isDirectory: false, size: 0, }; if (!directory.isDirectory) { return false; } let array: Record<string, unknown>[]; if (!directory.dataItem) { array = fileItems; } else { array = directory.dataItem.items; if (!array) { array = []; directory.dataItem.items = array; } } array.push(newItem); return true; } function updateCategory(newCategory: string, directory: FileSystemItem, viewArea: string) { let items: FileSystemItem[] = []; if (viewArea === 'navPane') { items = [directory]; } else { items = fileManager.value.instance.getSelectedItems(); } items.forEach((item: FileSystemItem) => { if (item.dataItem) { item.dataItem.category = newCategory; } }); return items.length > 0; } function getNewFileMenuOptions() { return { items: [ { text: 'Create new file', icon: 'plus', items: [ { text: 'Text Document', options: { extension: '.txt', }, }, { text: 'RTF Document', options: { extension: '.rtf', }, }, { text: 'Spreadsheet', options: { extension: '.xls', }, }, ], }, ], onItemClick, }; } function getChangeCategoryMenuOptions() { return { items: [ { text: 'Category', icon: 'tags', items: [ { text: 'Work', options: { category: 'Work', }, }, { text: 'Important', options: { category: 'Important', }, }, { text: 'Home', options: { category: 'Home', }, }, { text: 'None', options: { category: '', }, }, ], }, ], onItemClick, }; } </script>
window.exports = window.exports || {}; window.config = { transpiler: false, meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'typescript': { 'exports': 'ts', }, 'vue': { format: 'global', exports: 'Vue', esModule: true, }, 'vuex': { format: 'global', exports: 'Vuex', esModule: true, }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, 'zod': { 'esModule': true, }, 'zod-to-json-schema': { 'esModule': true, }, 'anti-forgery': { loader: 'demo-ts-loader', }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'vue': 'npm:vue@3.5.32/dist/vue.global.js', '@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js', 'vue-loader': 'project:utils/demo-vue-loader.js', 'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js', 'demo-ts-loader': 'project:utils/demo-ts-loader.js', 'demo-ts-shared': 'project:utils/demo-ts-shared.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'svg-loader': 'project:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs', 'zod': 'externals:zod.bundle.js', 'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js', 'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme-vue/common': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai']; let packagesInfo = { "zod": { "version": "3.24.4" }, "zod-to-json-schema": { "version": "3.24.6" } };
export const fileItems = [{ name: 'Documents', isDirectory: true, category: 'Work', items: [{ name: 'Projects', isDirectory: true, category: 'Work', items: [{ name: 'About.rtf', isDirectory: false, size: 1024, }, { name: 'Passwords.rtf', isDirectory: false, category: 'Important', size: 2048, }], }, { name: 'About.xml', isDirectory: false, size: 1024, }, { name: 'Managers.rtf', isDirectory: false, size: 2048, }, { name: 'ToDo.txt', isDirectory: false, size: 3072, }], }, { name: 'Images', isDirectory: true, category: 'Home', items: [{ name: 'logo.png', isDirectory: false, size: 20480, }, { name: 'banner.gif', isDirectory: false, size: 10240, }], }, { name: 'System', isDirectory: true, category: 'Important', items: [{ name: 'Employees.txt', isDirectory: false, category: 'Important', size: 3072, }, { name: 'PasswordList.txt', isDirectory: false, category: 'Important', size: 5120, }], }, { name: 'Description.rtf', isDirectory: false, size: 1024, }, { name: 'Description.txt', isDirectory: false, size: 2048, }]; const fileExtensions: Record<string, string> = { 'Text Document': '.txt', 'RTF Document': '.rtf', Spreadsheet: '.xls', }; const categories = ['Work', 'Important', 'Home', 'None']; export function getItemInfo(name: string) { const extension = fileExtensions[name]; const category = extension ?? categories.find((cat) => cat === name); return { extension, category, }; }
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <script type="module"> import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> <span v-if="false">Loading...</span> </div> </div> </body> </html>

DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

React File Manager - Toolbar and Context Menu

The FileManager component provides the following UI customization properties:

  • The toolbar property specifies the toolbar's visibility and available commands.
  • The contextMenu property specifies the context menu's availability and its commands.

The toolbar and context menu support context-invariant and context-sensitive items that can be visible or hidden depending on user action.

Backend API
import React, { useCallback, useRef } from 'react'; import FileManager, { Permissions, Toolbar, ContextMenu, Item, FileSelectionItem, ItemView, Details, Column, } from 'devextreme-react/file-manager'; import type { FileManagerRef } from 'devextreme-react/file-manager'; import { fileItems, getItemInfo } from './data.ts'; interface FileSystemItem { name: string; isDirectory: boolean; size?: number; items?: FileSystemItem[]; } export default function App() { const fileManagerRef = useRef<FileManagerRef>(null); const createFile = useCallback(( fileExtension, directory = fileManagerRef?.current?.instance()?.getCurrentDirectory(), ) => { const newItem = { __KEY__: Date.now(), name: `New file${fileExtension}`, isDirectory: false, size: 0, }; if (!directory?.isDirectory) { return false; } let array: FileSystemItem[]; if (!directory?.dataItem) { array = fileItems; } else { array = directory.dataItem.items; if (!array) { array = []; directory.dataItem.items = array; } } array.push(newItem); return true; }, []); const updateCategory = useCallback((newCategory, directory, viewArea: string) => { let items = null; if (viewArea === 'navPane') { items = [directory]; } else { items = fileManagerRef?.current?.instance()?.getSelectedItems(); } items?.forEach((item: { dataItem: { category: any; }; }) => { if (item.dataItem) { item.dataItem.category = newCategory; } }); return items && items.length > 0; }, []); const onItemClick = useCallback(({ itemData, viewArea, fileSystemItem }) => { let updated: boolean | undefined = false; const { extension, category } = getItemInfo(itemData.text); if (extension) { updated = createFile(extension, fileSystemItem); } else if (category !== undefined) { updated = updateCategory(category, fileSystemItem, viewArea); } if (updated) { fileManagerRef?.current?.instance()?.refresh(); } }, [createFile, updateCategory]); const getNewFileMenuOptions = useCallback(() => ({ items: [ { text: 'Create new file', icon: 'plus', items: [ { text: 'Text Document', extension: '.txt', }, { text: 'RTF Document', extension: '.rtf', }, { text: 'Spreadsheet', extension: '.xls', }, ], }, ], onItemClick, }), [onItemClick]); const getChangeCategoryMenuOptions = useCallback(() => ({ items: [ { text: 'Category', icon: 'tags', items: [ { text: 'Work', category: 'Work', }, { text: 'Important', category: 'Important', }, { text: 'Home', category: 'Home', }, { text: 'None', category: '', }, ], }, ], onItemClick, }), [onItemClick]); return ( <FileManager ref={fileManagerRef} fileSystemProvider={fileItems} onContextMenuItemClick={onItemClick} height={450}> <Permissions create={true} delete={true} rename={true} download={true}> </Permissions> <ItemView showParentFolder={false}> <Details> <Column dataField="thumbnail"></Column> <Column dataField="name"></Column> <Column dataField="category" caption="Category" width="95"></Column> <Column dataField="dateModified"></Column> <Column dataField="size"></Column> </Details> </ItemView> <Toolbar> <Item name="showNavPane" visible={true} /> <Item name="separator" /> <Item name="create" /> <Item widget="dxMenu" location="before" options={getNewFileMenuOptions()} /> <Item name="refresh" /> <Item name="separator" location="after" /> <Item name="switchView" /> <FileSelectionItem name="rename" /> <FileSelectionItem name="separator" /> <FileSelectionItem name="delete" /> <FileSelectionItem name="separator" /> <FileSelectionItem widget="dxMenu" location="before" options={getChangeCategoryMenuOptions()} /> <FileSelectionItem name="refresh" /> <FileSelectionItem name="clearSelection" /> </Toolbar> <ContextMenu> <Item name="create" /> <Item text="Create new file" icon="plus"> <Item text="Text Document" /> <Item text="RTF Document" /> <Item text="Spreadsheet" /> </Item> <Item name="rename" beginGroup /> <Item name="delete" /> <Item text="Category" icon="tags" beginGroup> <Item text="Work" /> <Item text="Important" /> <Item text="Home" /> <Item text="None" /> </Item> <Item name="refresh" /> </ContextMenu> </FileManager> ); }
import React, { useCallback, useRef } from 'react'; import FileManager, { Permissions, Toolbar, ContextMenu, Item, FileSelectionItem, ItemView, Details, Column, } from 'devextreme-react/file-manager'; import { fileItems, getItemInfo } from './data.js'; export default function App() { const fileManagerRef = useRef(null); const createFile = useCallback((fileExtension, directory = fileManagerRef?.current ?.instance() ?.getCurrentDirectory()) => { const newItem = { __KEY__: Date.now(), name: `New file${fileExtension}`, isDirectory: false, size: 0, }; if (!directory?.isDirectory) { return false; } let array; if (!directory?.dataItem) { array = fileItems; } else { array = directory.dataItem.items; if (!array) { array = []; directory.dataItem.items = array; } } array.push(newItem); return true; }, []); const updateCategory = useCallback((newCategory, directory, viewArea) => { let items = null; if (viewArea === 'navPane') { items = [directory]; } else { items = fileManagerRef?.current?.instance()?.getSelectedItems(); } items?.forEach((item) => { if (item.dataItem) { item.dataItem.category = newCategory; } }); return items && items.length > 0; }, []); const onItemClick = useCallback( ({ itemData, viewArea, fileSystemItem }) => { let updated = false; const { extension, category } = getItemInfo(itemData.text); if (extension) { updated = createFile(extension, fileSystemItem); } else if (category !== undefined) { updated = updateCategory(category, fileSystemItem, viewArea); } if (updated) { fileManagerRef?.current?.instance()?.refresh(); } }, [createFile, updateCategory], ); const getNewFileMenuOptions = useCallback( () => ({ items: [ { text: 'Create new file', icon: 'plus', items: [ { text: 'Text Document', extension: '.txt', }, { text: 'RTF Document', extension: '.rtf', }, { text: 'Spreadsheet', extension: '.xls', }, ], }, ], onItemClick, }), [onItemClick], ); const getChangeCategoryMenuOptions = useCallback( () => ({ items: [ { text: 'Category', icon: 'tags', items: [ { text: 'Work', category: 'Work', }, { text: 'Important', category: 'Important', }, { text: 'Home', category: 'Home', }, { text: 'None', category: '', }, ], }, ], onItemClick, }), [onItemClick], ); return ( <FileManager ref={fileManagerRef} fileSystemProvider={fileItems} onContextMenuItemClick={onItemClick} height={450} > <Permissions create={true} delete={true} rename={true} download={true} ></Permissions> <ItemView showParentFolder={false}> <Details> <Column dataField="thumbnail"></Column> <Column dataField="name"></Column> <Column dataField="category" caption="Category" width="95" ></Column> <Column dataField="dateModified"></Column> <Column dataField="size"></Column> </Details> </ItemView> <Toolbar> <Item name="showNavPane" visible={true} /> <Item name="separator" /> <Item name="create" /> <Item widget="dxMenu" location="before" options={getNewFileMenuOptions()} /> <Item name="refresh" /> <Item name="separator" location="after" /> <Item name="switchView" /> <FileSelectionItem name="rename" /> <FileSelectionItem name="separator" /> <FileSelectionItem name="delete" /> <FileSelectionItem name="separator" /> <FileSelectionItem widget="dxMenu" location="before" options={getChangeCategoryMenuOptions()} /> <FileSelectionItem name="refresh" /> <FileSelectionItem name="clearSelection" /> </Toolbar> <ContextMenu> <Item name="create" /> <Item text="Create new file" icon="plus" > <Item text="Text Document" /> <Item text="RTF Document" /> <Item text="Spreadsheet" /> </Item> <Item name="rename" beginGroup /> <Item name="delete" /> <Item text="Category" icon="tags" beginGroup > <Item text="Work" /> <Item text="Important" /> <Item text="Home" /> <Item text="None" /> </Item> <Item name="refresh" /> </ContextMenu> </FileManager> ); }
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.tsx'; ReactDOM.render( <App />, document.getElementById('app'), );
export const fileItems = [{ name: 'Documents', isDirectory: true, category: 'Work', items: [{ name: 'Projects', isDirectory: true, category: 'Work', items: [{ name: 'About.rtf', isDirectory: false, size: 1024, }, { name: 'Passwords.rtf', isDirectory: false, category: 'Important', size: 2048, }], }, { name: 'About.xml', isDirectory: false, size: 1024, }, { name: 'Managers.rtf', isDirectory: false, size: 2048, }, { name: 'ToDo.txt', isDirectory: false, size: 3072, }], }, { name: 'Images', isDirectory: true, category: 'Home', items: [{ name: 'logo.png', isDirectory: false, size: 20480, }, { name: 'banner.gif', isDirectory: false, size: 10240, }], }, { name: 'System', isDirectory: true, category: 'Important', items: [{ name: 'Employees.txt', isDirectory: false, category: 'Important', size: 3072, }, { name: 'PasswordList.txt', isDirectory: false, category: 'Important', size: 5120, }], }, { name: 'Description.rtf', isDirectory: false, size: 1024, }, { name: 'Description.txt', isDirectory: false, size: 2048, }]; const fileExtensions = { 'Text Document': '.txt', 'RTF Document': '.rtf', Spreadsheet: '.xls', } as const; type FileExtensionName = keyof typeof fileExtensions; const categories = ['Work', 'Important', 'Home', 'None']; export function getItemInfo(name: FileExtensionName) { const extension = fileExtensions[name]; const category = extension ?? categories.find((cat) => cat === name); return { extension, category, }; }
window.exports = window.exports || {}; window.config = { transpiler: false, meta: { '*.ts': { loader: 'demo-ts-loader', }, '*.tsx': { loader: 'demo-ts-loader', typescriptOptions: { jsx: 'react', }, }, 'typescript': { 'exports': 'ts', }, 'anti-forgery': { loader: 'demo-ts-loader', }, 'react': { 'esModule': true, }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, 'zod': { 'esModule': true, }, 'zod-to-json-schema': { 'esModule': true, }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, defaultExtension: 'js', map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'demo-ts-loader': 'project:utils/demo-ts-loader.js', 'demo-ts-shared': 'project:utils/demo-ts-shared.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types/prop-types.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs', 'zod': 'externals:zod.bundle.js', 'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js', 'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', 'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme-react/common': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/localization/messages': { format: 'json', defaultExtension: 'json', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai']; let packagesInfo = { "zod": { "version": "3.24.4" }, "zod-to-json-schema": { "version": "3.24.6" } };
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render(<App />, document.getElementById('app'));
export const fileItems = [ { name: 'Documents', isDirectory: true, category: 'Work', items: [ { name: 'Projects', isDirectory: true, category: 'Work', items: [ { name: 'About.rtf', isDirectory: false, size: 1024, }, { name: 'Passwords.rtf', isDirectory: false, category: 'Important', size: 2048, }, ], }, { name: 'About.xml', isDirectory: false, size: 1024, }, { name: 'Managers.rtf', isDirectory: false, size: 2048, }, { name: 'ToDo.txt', isDirectory: false, size: 3072, }, ], }, { name: 'Images', isDirectory: true, category: 'Home', items: [ { name: 'logo.png', isDirectory: false, size: 20480, }, { name: 'banner.gif', isDirectory: false, size: 10240, }, ], }, { name: 'System', isDirectory: true, category: 'Important', items: [ { name: 'Employees.txt', isDirectory: false, category: 'Important', size: 3072, }, { name: 'PasswordList.txt', isDirectory: false, category: 'Important', size: 5120, }, ], }, { name: 'Description.rtf', isDirectory: false, size: 1024, }, { name: 'Description.txt', isDirectory: false, size: 2048, }, ]; const fileExtensions = { 'Text Document': '.txt', 'RTF Document': '.rtf', Spreadsheet: '.xls', }; const categories = ['Work', 'Important', 'Home', 'None']; export function getItemInfo(name) { const extension = fileExtensions[name]; const category = extension ?? categories.find((cat) => cat === name); return { extension, category, }; }
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.tsx"); </script> <link rel="stylesheet" type="text/css" href="styles.css" /> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>